/*
* Copyright (c) 2005-08, Craig Bishop and Colin Graeme Johnson
* All rights reserved.
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions are met:
*     * Redistributions of source code must retain the above copyright
*       notice, this list of conditions and the following disclaimer.
*     * Redistributions in binary form must reproduce the above copyright
*       notice, this list of conditions and the following disclaimer in the
*       documentation and/or other materials provided with the distribution.
*     * Neither the names of Craig Bishop and/or Colin Graeme Johnson, 
*       nor the name of the University of Kent may be used to endorse 
*       or promote products derived from this software without
*       specific prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY COLIN GRAEME JOHNSON ``AS IS'' AND ANY
* EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
* DISCLAIMED. IN NO EVENT SHALL COLIN GRAEME JOHNSON BE LIABLE FOR ANY
* DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
* (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
* ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
* (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
* SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

/*
 * Created on 15-Jul-2005
 */
package main.progAnal;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Set;

/**
 * @author cbishop
 */
public class MethodGetter extends ProgramAnalyser {

	/**
	 * Return list of method names in source code
	 * 
	 * @param sortedStatements
	 *            HashMap being program slice for variable
	 * @return ArrayList of method names in program
	 */
	public ArrayList getMethods(HashMap sortedStatements) {
		ArrayList methods = new ArrayList();
		Set keySet = sortedStatements.keySet();
		Iterator it = keySet.iterator();
		String variable = (String) it.next(); //get first available variable
		ArrayList sortedArray = (ArrayList) sortedStatements.get(variable);
		it = sortedArray.iterator();
		while (it.hasNext()) {
			String statement = (String) it.next();
			if (methodStatement(statement)) {
				//add name of method to methods
				int j = 0;
				String reverseName = "";
				for (int i = 0; i < statement.length(); i++) {
					String statementSubstring = statement.substring(i);
					if (statementSubstring.startsWith("(")) { //where method
															  // name ends
						j = i - 1;
						i = statement.length();
					}
				}
				int position = 0; //so that possible gap between method name
								  // and '(' is not interpreted as method name
				while (j > 0) { //work backwards adding method name to
								// reverseName until beginning of method name
					String charString = statement.substring(j, j + 1);
					if (charString.equals(" ") && position > 0) {
						//look for space before method name
						j = 0;
					}
					reverseName += charString;
					j--;
					position++;
				}
				String methodName = "";
				for (j = reverseName.length() - 1; j >= 0; j--) {
					methodName += reverseName.substring(j, j + 1);
				}
				methods.add(methodName);
				//System.out.println(methodName); debug
			}
		}
		return methods;
	}
}